'Create Users Accounts in Windows NT domain
'Would work with Active Directory, however LDAP would be prefered in AD
'Original code obtained: http://techtasks.com/code/viewbookcode/237
'Modified to use loop and create users from list

'**********************************************************************
'Flag constants. See the later sidebar on "Boolean Arithmetic with
'Hexadecimal Values."
'**********************************************************************
Const UF_SCRIPT = &H1
Const UF_ACCOUNTDISABLE = &H2
Const UF_LOCKOUT = &H10
Const UF_PASSWD_NOTREQD = &H20
Const UF_PASSWORD_CANT_CHANGE = &H40
Const UF_ENCRYPTED_TEXT_PASSWORD_ALLOWED = &H80
Const UF_DONT_EXPIRE_PASSWD = &H10000

'Declare objects required for script
Set fso = CreateObject("Scripting.FileSystemObject")

Set passlist = fso.OpenTextFile("passlist.txt")
While Not passlist.AtEndOfStream
	line = passlist.ReadLine
	
	WScript.Echo CreateUser(line)
	
Wend
Set passlist = Nothing
	

Function CreateUser(strPassword)
	Set objDomain = GetObject("WinNT://406PASSWORD")
	Set objUser = objDomain.Create("user","passctrl-" & strPassword)
	
	'**********************************************************************
	'Write the newly created object out from the property cache and read
	'all the properties for the object, including the ones set by the
	'system on creation
	'**********************************************************************
	objUser.SetInfo
	objUser.GetInfo
	
	'**********************************************************************
	'Set the properties
	'**********************************************************************
	objUser.AccountDisabled = False
	objUser.FullName = strPasssword
	objUser.IsAccountLocked = False
	objUser.LoginScript = "login.vbs"
	objUser.PasswordRequired = True
	
	'**********************************************************************
	'Set all the properties for the user and read back the data, including
	'any default so that you can set the flags
	'**********************************************************************
	objUser.SetInfo
	objUser.GetInfo
	
	'**********************************************************************
	'Make sure the password never expires and the user can't change it
	'**********************************************************************
	intUserFlags = objUser.Get("userFlags")
	intNewUserFlags = intUserFlags Or UF_DONT_EXPIRE_PASSWD
	intNewUserFlags = intNewUserFlags Or UF_PASSWORD_CANT_CHANGE
	objUser.Put "userFlags", intNewUserFlags
	objUser.SetInfo
	
	'**********************************************************************
	'Set the password
	'**********************************************************************
	'The passwords will be semi-unique.  The plan was to use first name + last name + #1
	'However, Windows NT 4 passwords are limited to 14 characters.  We will instead use
	'the first two characters of the first name + first two characters of last name + #1
	objUser.SetPassword strPassword
	
	CreateUser = "Created user account for passctrl-" & strPassword & " with password " & strPassword
	Set objUser = Nothing
	Set objDomain = Nothing 
End function
